/******************************************************************************/
/****         Generated by IBExpert 2006.10.14 10.11.2006 21:51:53         ****/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES NONE;

SET CLIENTLIB 'C:\Program Files\Firebird\Firebird_2_0\bin\fbclient.dll';



/******************************************************************************/
/****                        User Defined Functions                        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION ASCII_CHAR
    INTEGER
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'IB_UDF_ascii_char' MODULE_NAME 'ib_udf';


DECLARE EXTERNAL FUNCTION LTRIM
    CSTRING(80)
    RETURNS CSTRING(80) FREE_IT
    ENTRY_POINT 'IB_UDF_ltrim' MODULE_NAME 'ib_udf';


DECLARE EXTERNAL FUNCTION RAND

    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'IB_UDF_rand' MODULE_NAME 'ib_udf';


DECLARE EXTERNAL FUNCTION RTRIM
    CSTRING(80)
    RETURNS CSTRING(80) FREE_IT
    ENTRY_POINT 'IB_UDF_rtrim' MODULE_NAME 'ib_udf';


DECLARE EXTERNAL FUNCTION STRLEN
    CSTRING(32767)
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'IB_UDF_strlen' MODULE_NAME 'ib_udf';




/******************************************************************************/
/****                              Generators                              ****/
/******************************************************************************/

CREATE GENERATOR GEN_LONG_NAME_FOR_A_TABLE_ID;
SET GENERATOR GEN_LONG_NAME_FOR_A_TABLE_ID TO 0;

CREATE GENERATOR GEN_PK_TABLE_ID;
SET GENERATOR GEN_PK_TABLE_ID TO 0;



SET TERM ^ ; 



/******************************************************************************/
/****                          Stored Procedures                           ****/
/******************************************************************************/

CREATE PROCEDURE "PRC_AmIAllowed" (
    "Right" CHAR(1),
    "Relation" VARCHAR(62))
RETURNS (
    "Status" SMALLINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PRC_AmIAllowedProc" (
    "ProcNamePart" VARCHAR(31))
RETURNS (
    "Name" VARCHAR(84),
    "Status" SMALLINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROCi_GetRandPassword"
RETURNS (
    "AutoPasswort" VARCHAR(20))
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROCSYS_DBCheckLong"
RETURNS (
    RES VARCHAR(84),
    FLD VARCHAR(60),
    TYP CHAR(10))
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROCSYS_DBCheckPKValues" (
    "ShowOnly" SMALLINT,
    "HideNothingToDo" SMALLINT)
RETURNS (
    "Name" VARCHAR(32),
    "MaxId" BIGINT,
    "MaxGen" BIGINT,
    "Message" VARCHAR(80),
    "GenName" VARCHAR(32))
AS
BEGIN
  EXIT;
END^



SET TERM ; ^


/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE PK_TABLE (
    "Id"     BIGINT NOT NULL,
    "VALUE"  BIGINT
);

CREATE TABLE VERY_LONG_NAME_FOR_A_TABLE (
    "Id"  BIGINT NOT NULL
);



/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE PK_TABLE ADD CONSTRAINT PK_PK_TABLE PRIMARY KEY ("Id");
ALTER TABLE VERY_LONG_NAME_FOR_A_TABLE ADD CONSTRAINT PK_VERY_LONG_NAME_FOR_A_TABLE PRIMARY KEY ("Id");


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: PK_TABLE_BI0 */
CREATE TRIGGER PK_TABLE_BI0 FOR PK_TABLE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_PK_TABLE_ID,1);
END
^

/* Trigger: VERY_LONG_NAME_FOR_A_TABLE_BI0 */
CREATE TRIGGER VERY_LONG_NAME_FOR_A_TABLE_BI0 FOR VERY_LONG_NAME_FOR_A_TABLE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_LONG_NAME_FOR_A_TABLE_ID,1);


END
^

SET TERM ; ^



/******************************************************************************/
/****                          Stored Procedures                           ****/
/******************************************************************************/


SET TERM ^ ;

ALTER PROCEDURE "PRC_AmIAllowed" (
    "Right" CHAR(1),
    "Relation" VARCHAR(62))
RETURNS (
    "Status" SMALLINT)
AS
DECLARE VARIABLE "IStatus" BIGINT;
begin
  "Status" =-1;

  SELECT count(RDB$RELATION_NAME)
  FROM RDB$USER_PRIVILEGES
  WHERE ((RDB$USER = current_user) or (RDB$USER = current_role) or (RDB$USER = 'PUBLIC'))
  AND RDB$RELATION_NAME = :"Relation" AND  RDB$PRIVILEGE = UPPER(:"Right")
  INTO "IStatus";

  if ("IStatus" >= 1) then
    "Status" = 1;
  else
    "Status" = 0;

-- Check for permission A when no rights yet
  if (("Status" = 0) and ("Right" IN ('S','I','U','D'))) then
    SELECT "Status"
    FROM "PRC_AmIAllowed"('A', :"Relation")
    INTO :"Status";

  suspend;
end
^

ALTER PROCEDURE "PRC_AmIAllowedProc" (
    "ProcNamePart" VARCHAR(31))
RETURNS (
    "Name" VARCHAR(84),
    "Status" SMALLINT)
AS
begin
  "ProcNamePart" = RTRIM(LTRIM("ProcNamePart"));

  if ("ProcNamePart" <> '') then begin
    FOR
      SELECT distinct(P.Rdb$Relation_Name) FROM RDB$USER_PRIVILEGES  P
      WHERE P.Rdb$Relation_Name CONTAINING :"ProcNamePart"
      AND P.RDB$OBJECT_TYPE=5
      INTO :"Name"
    DO BEGIN
      "Name"=RTRIM(LTRIM("Name"));

      SELECT "Status"
      FROM "PRC_AmIAllowed"('X', :"Name")
      INTO :"Status";

      suspend;
    END
  end else begin
    FOR
      SELECT distinct(P.Rdb$Relation_Name) FROM RDB$USER_PRIVILEGES  P
      --WHERE P.Rdb$Relation_Name CONTAINING :"ProcNamePart"
      WHERE P.RDB$OBJECT_TYPE=5
      INTO :"Name"
    DO BEGIN
      "Name"=RTRIM(LTRIM("Name"));

      SELECT "Status"
      FROM "PRC_AmIAllowed"('X', :"Name")
      INTO :"Status";
      suspend;
    END
  end
end
^

ALTER PROCEDURE "PROCi_GetRandPassword"
RETURNS (
    "AutoPasswort" VARCHAR(20))
AS
DECLARE VARIABLE "SollLang" INTEGER;
DECLARE VARIABLE "Wert" INTEGER;
DECLARE VARIABLE "Last" INTEGER;
begin
  -- Get length
  /*SELECT "Value"
  FROM "PROCSYS_CNFGetInteger"(-1, 'SYS_AutoPWLength')
  INTO :"SollLang";

  if ("SollLang" > 20) then
    "SollLang" = 20;*/

  "SollLang" = 8;

  "AutoPasswort" = '';
  "Last" = 0;
  "Wert" = 0;
  while (STRLEN("AutoPasswort") < "SollLang") do begin
    while ((not "Wert" between 33 and 122) or ("Wert" = "Last")) do begin
      "Wert" = RAND()*89+33;
    end

    "AutoPasswort" = "AutoPasswort" || ASCII_CHAR("Wert");
    "Last" = "Wert";
  end

  suspend;
end
^

ALTER PROCEDURE "PROCSYS_DBCheckLong"
RETURNS (
    RES VARCHAR(84),
    FLD VARCHAR(60),
    TYP CHAR(10))
AS
DECLARE VARIABLE Rn CHAR(31);
DECLARE VARIABLE Rf CHAR(31);
DECLARE VARIABLE Ruser CHAR(31);
DECLARE VARIABLE L BIGINT;
begin
  FOR SELECT P.RDB$RELATION_NAME, P.RDB$FIELD_NAME, P.RDB$USER FROM RDB$USER_PRIVILEGES P
  INTO :RN, :RF, :RUSER DO BEGIN
    FLD = RTRIM(RN);
    IF (Strlen(FLD) > 27) THEN BEGIN
      RES = FLD || ' too long';
      TYP = 'N';
      suspend;
    END

    FLD= RTRIM(RF);
    IF (Strlen(FLD) > 27) THEN BEGIN
      RES = FLD || ' too long';
      TYP = 'F';
      suspend;
    END

    FLD= RTRIM(RUSER);
    IF (Strlen(FLD) > 27) THEN BEGIN
      RES = FLD || ' too long';
      TYP = 'U';
      suspend;
    END
  END

end
^

ALTER PROCEDURE "PROCSYS_DBCheckPKValues" (
    "ShowOnly" SMALLINT,
    "HideNothingToDo" SMALLINT)
RETURNS (
    "Name" VARCHAR(32),
    "MaxId" BIGINT,
    "MaxGen" BIGINT,
    "Message" VARCHAR(80),
    "GenName" VARCHAR(32))
AS
DECLARE VARIABLE Q VARCHAR(1000);
DECLARE VARIABLE "Gen" VARCHAR(32);
DECLARE VARIABLE "Count" BIGINT;
begin
  if ("ShowOnly" IS NULL) then
    "ShowOnly" = 1;

  if ("HideNothingToDo" IS NULL) then
    "HideNothingToDo" = 1;

  FOR SELECT RDB$RELATION_NAME --, RDB$DESCRIPTION
    FROM RDB$RELATIONS R
    WHERE RDB$VIEW_BLR IS NULL AND RDB$SYSTEM_FLAG = 0
--    AND (((RDB$RELATION_NAME  starting with 'FAU') AND (RDB$RELATION_NAME containing '_')) OR (RDB$RELATION_NAME = 'DBINFO'))
    ORDER BY 1
    INTO :"Name" --, :"Description"
    DO BEGIN

    "Name" = RTrim("Name");

    "Message" = '';
    BEGIN
      "MaxId" = NULL;
      Q = 'SELECT CAST(Max("Id") AS BIGINT), CAST(Count("Id") AS BIGINT) FROM "'|| "Name"||'";';
      EXECUTE STATEMENT Q INTO :"MaxId", :"Count";
    WHEN ANY DO
      "MaxId" = NULL;
    END

    if ("MaxId" IS NULL) then begin
      "MaxId" = NULL;
      Q = 'SELECT CAST(Max("ID") AS BIGINT), CAST(Count("ID") AS BIGINT) FROM "'|| "Name"||'";';
      EXECUTE STATEMENT Q INTO :"MaxId", :"Count";
    WHEN ANY DO
      "MaxId" = NULL;
    end

    BEGIN
      "Gen" = 'GEN_'||"Name"||'_ID'; -- Gesuchert Name

      "GenName" = NULL; -- Echter Name
      SELECT RDB$GENERATOR_NAME
      FROM RDB$GENERATORS
      WHERE ((RDB$SYSTEM_FLAG IS NULL) or (RDB$SYSTEM_FLAG = 0)) AND UPPER(RDB$GENERATOR_NAME) = UPPER(:"Gen")
      INTO :"GenName";

      if ("GenName" IS NULL) then begin
        "Gen" = 'GEN_'||"Name";
        --"GenName" = NULL;
        SELECT RDB$GENERATOR_NAME
        FROM RDB$GENERATORS
        WHERE ((RDB$SYSTEM_FLAG IS NULL) or (RDB$SYSTEM_FLAG = 0))  AND UPPER(RDB$GENERATOR_NAME) = UPPER(:"Gen")
        INTO :"GenName";
      end

      if ("GenName" IS NOT NULL) then begin
        "GenName" = RTrim("GenName");
        "MaxGen" = NULL;
        Q = 'SELECT GEN_ID("'||:"GenName"||'",0) FROM RDB$DATABASE;';
        EXECUTE STATEMENT  Q INTO :"MaxGen";
      end else
        "MaxGen" = NULL;
    WHEN ANY DO
      "MaxGen" = NULL;
    END

    if ("MaxId" IS NULL) then  begin
      if ("Count" = 0) then begin
--        "Message" = 'Tabelle ist leer!';
        "MaxId" = 0;  -- Bei leerer Tabelle Wert auf 0 setzen
      end else
        "Message" = 'table has no default format or you don''t have enought permissions!';
    end else if ("MaxGen" IS NULL) then
      "Message" = 'generator '|| COALESCE("GenName","Gen",'no name') || ' not found or no permissions!';


    if ("Message" = '') then begin
      if ("MaxGen" <> "MaxId") then begin -- Korrektur notwendig                                   --
        if ("ShowOnly" = 0) then begin
          "Message" = 'generator corrected for '|| (:"MaxId"-:"MaxGen");
          Q = 'SET GENERATOR "'||:"GenName"|| '" to '|| "MaxId"||';';
          EXECUTE STATEMENT  Q;
          WHEN ANY DO
            "Message" = 'error correcting generator '||"GenName";
        end else begin
          -- ShowOnly = 1
          "Message" = 'generater has to be corrected for '|| (:"MaxId"-:"MaxGen");
        end

        if ("HideNothingToDo" = 1) then
          suspend;

      end else begin
        "Message" = 'generator and table are compatible';
      end
    end -- If

    if ("HideNothingToDo" <> 1) then
      suspend;
  end -- FOR SELECT
end
^


SET TERM ; ^


/******************************************************************************/
/****                                Roles                                 ****/
/******************************************************************************/

CREATE ROLE A_VERY_LONG_NAME_FOR_A_ROLE;


/******************************************************************************/
/****                             Descriptions                             ****/
/******************************************************************************/

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Gibt zurck,ob ein User ein Recht hat
Geprft wird, ob das Recht auf Public, current_role oder current_user vergeben ist

Right:
S = Select
X = Execute
I = Insert
U = Update
D = Delete
M = Member Of Role

Rckgabe:
-1 : Fehler (Darf nicht auftreten)
 0 : Berechtigung liegt nicht vor
 1 : Berechtigung liegt vor'
WHERE (RDB$PROCEDURE_NAME = 'PRC_AmIAllowed');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Ruft PRC_AmIAllowed auf mit dem Recht ''X'' fr Execute fr alle Prozeduren,
die ProcNamePart im Namen haben (CONTAINING)

Rckgabe "Name":
Name der Prozedur

Rckgabe "Status":
-1 : Fehler (Darf nicht auftreten)
 0 : Berechtigung liegt nicht vor
 1 : Berechtigung liegt vor'
WHERE (RDB$PROCEDURE_NAME = 'PRC_AmIAllowedProc');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'checks structure of firebird for too long values, which may cause problems with gbak
type:
T: table
F: field
U: user'
WHERE (RDB$PROCEDURE_NAME = 'PROCSYS_DBCheckLong');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'check pk values and correct the generators,
which are named GEN_<TABLENAME>_ID or GEN_<TABLENAME>'
WHERE (RDB$PROCEDURE_NAME = 'PROCSYS_DBCheckPKValues');

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'Generate random pw'
WHERE (RDB$PROCEDURE_NAME = 'PROCi_GetRandPassword');



/* Parameters descriptions */

UPDATE RDB$PROCEDURE_PARAMETERS
SET RDB$DESCRIPTION = 'Teil eines Proc-Namens'
WHERE (RDB$PROCEDURE_NAME = 'PRC_AmIAllowedProc') AND (RDB$PARAMETER_NAME = 'ProcNamePart');

UPDATE RDB$PROCEDURE_PARAMETERS
SET RDB$DESCRIPTION = '1 = hide where nothing is to do'
WHERE (RDB$PROCEDURE_NAME = 'PROCSYS_DBCheckPKValues') AND (RDB$PARAMETER_NAME = 'HideNothingToDo');

UPDATE RDB$PROCEDURE_PARAMETERS
SET RDB$DESCRIPTION = '1= ShowOnly , otherwiese correct generators'
WHERE (RDB$PROCEDURE_NAME = 'PROCSYS_DBCheckPKValues') AND (RDB$PARAMETER_NAME = 'ShowOnly');

COMMIT WORK;



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, REFERENCES ON PK_TABLE TO A_VERY_LONG_NAME_FOR_A_ROLE;
GRANT ALL ON VERY_LONG_NAME_FOR_A_TABLE TO A_VERY_LONG_NAME_FOR_A_ROLE;

/* Privileges of triggers */
GRANT UPDATE, REFERENCES ON PK_TABLE TO TRIGGER PK_TABLE_BI0;
GRANT UPDATE, REFERENCES ON VERY_LONG_NAME_FOR_A_TABLE TO TRIGGER VERY_LONG_NAME_FOR_A_TABLE_BI0;
